## dose3 3.3~beta1

=== Makefile ===
#this is a forward reference to the target all below
all: all

#SHELL=/bin/bash
include Makefile.config

DIST_DIR = $(NAME)-$(VERSION)
DIST_TARBALL = $(DIST_DIR).tar.gz

VERBOSE := -classic-display
OBFLAGS := $(VERBOSE) -j 10 -no-links -cflags -warn-error,FPSXY
APPFLAGS := $(VERBOSE) -j 10
#OBFLAGS := $(OBFLAGS) -tag profile -tag debug
#OBFLAGS := $(OBFLAGS) -classic-display

all: itarget $(CAMLP4CMXS) $(BYTELIBS) $(OPTLIBS) $(CMXSLIBS) $(ALIBS) man
	$(OCAMLBUILD) $(APPFLAGS) applications/apps.otarget

apps: itarget $(CAMLP4CMXS) $(BYTELIBS) $(OPTLIBS) 
	echo $(LIBNAMES)
	echo $(BYTELIBS)
	echo $(OPTLIBS)
	$(OCAMLBUILD) $(APPFLAGS) applications/apps.otarget

cleandoselib:
	rm -Rf $(DOSELIBS)

itarget:
	rm -f applications/apps.itarget
	@for i in $(TARGETS); do echo $$i >> applications/apps.itarget; done
	$(shell \
		for lib in $(LIBNAMES); do \
			libname=`basename "$$lib"` ;\
			dirname=`dirname "$$lib"` ;\
			rm -f $$dirname/$$libname.itarget ;\
			for ext in $(SUFFIX); do \
				echo "$$libname.$$ext" >> $$dirname/$$libname.itarget; \
			done;\
		done)
#	@touch applications/.itarget

_build/Camlp4MacroParser.cmxs:
	mkdir -p _build
	ocamlopt -shared $(shell ocamlc -where)/camlp4/Camlp4Parsers/Camlp4MacroParser.cmx -o _build/Camlp4MacroParser.cmxs

$(DOSELIBS)/cudf.%:
	$(OCAMLBUILD) $(OBFLAGS) cudf/cudf.$*
	@mkdir -p $(DOSELIBS)
	@cp _build/cudf/*.cmi $(DOSELIBS)
	@for i in _build/cudf/cudf.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

$(DOSELIBS)/common.%: common/*.ml
	$(OCAMLBUILD) $(OBFLAGS) common/common.otarget
	@mkdir -p $(DOSELIBS)
	@for i in _build/common/common.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

$(DOSELIBS)/algo.%: algo/*.ml $(DOSELIBS)/common.%
	$(OCAMLBUILD) $(OBFLAGS) algo/algo.otarget
	@for i in _build/algo/algo.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

$(DOSELIBS)/debian.%: deb/*.ml $(DOSELIBS)/algo.%
	$(OCAMLBUILD) $(OBFLAGS) deb/debian.otarget
	@for i in _build/deb/debian.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

$(DOSELIBS)/rpm.%: rpm/*.ml $(DOSELIBS)/algo.%
	$(OCAMLBUILD) $(OBFLAGS) rpm/rpm.otarget
	@for i in _build/rpm/rpm.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

$(DOSELIBS)/eclipse.%: eclipse/*.ml $(DOSELIBS)/debian.%
	$(OCAMLBUILD) $(OBFLAGS) eclipse/eclipse.otarget
	@for i in _build/eclipse/eclipse.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

$(DOSELIBS)/csw.%: opencsw/*.ml $(DOSELIBS)/debian.%
	$(OCAMLBUILD) $(OBFLAGS) opencsw/csw.otarget
	@for i in _build/opencsw/csw.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

$(DOSELIBS)/cv.%:
	$(OCAMLBUILD) $(OBFLAGS) cv/cv.otarget
	@for i in _build/cv/cv.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

$(DOSELIBS)/doseparse.%: $(DOSELIBS)/debian.% $(DOSELIBS)/eclipse.%
	$(OCAMLBUILD) $(OBFLAGS) doseparse/doseparse.otarget
	@for i in _build/doseparse/doseparse.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx $(DOSELIBS)/*.ml ; \
	  fi ; \
	done

$(DOSELIBS)/doseparseNoRpm.%: $(DOSELIBS)/debian.% $(DOSELIBS)/eclipse.%
	$(OCAMLBUILD) $(OBFLAGS) doseparseNoRpm/doseparseNoRpm.otarget
	@for i in _build/doseparseNoRpm/doseparseNoRpm.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

clean:
	$(OCAMLBUILD) -clean
	rm -f applications/apps.itarget applications/.itarget
	cd doc && $(MAKE) clean

distclean: clean
	rm -Rf Makefile.config aclocal.m4 config.log config.status autom4te.cache/
	rm -f algo/algo.mlpack
	rm -f common/versionInfo.ml
	rm -f db/db.mlpack
	rm -f _tags META

testapps: apps 
	@applications/dose-tests.py applications/dose-tests.list

testlib: 
	@for i in $(TESTS); do\
		echo "#######START TESTING $$i" ;\
		$(OCAMLBUILD) $(APPFLAGS) $$i/tests.$(OCAMLEXT) ;\
		./tests.$(OCAMLEXT) ;\
	done

test: testapps testlib

# stuff not not put in a distribution tarball
DIST_EXCLUDE = cudf tests $(wildcard */tests) experimental

INSTALL_STUFF_ = META
INSTALL_STUFF_ += $(wildcard _build/doselibs/*.cma _build/doselibs/*.cmi)
INSTALL_STUFF_ += $(wildcard _build/doselibs/*.cmxa _build/doselibs/*.cmxs)
INSTALL_STUFF_ += $(wildcard _build/doselibs/*.a)
INSTALL_STUFF_ += $(wildcard _build/*/*.mli)
INSTALL_STUFF_ += $(wildcard _build/rpm/*.so _build/rpm/*.a)

exclude_cudf = $(wildcard _build/doselibs/*cudf* _build/cudf/*)
INSTALL_STUFF = $(filter-out $(exclude_cudf), $(INSTALL_STUFF_))

install: META installcudf
	test -d $(LIBDIR) || mkdir -p $(LIBDIR)
	test -d $(LIBDIR)/stublibs || mkdir -p $(LIBDIR)/stublibs
	$(INSTALL) -patch-version $(VERSION) $(NAME) $(INSTALL_STUFF)

	# install applications
	cd _build/applications ; \
	install -d $(BINDIR) ; \
	for f in $$(ls *.$(OCAMLEXT)) ; do \
	  install $(INSTALLOPTS) $$f $(BINDIR)/$${f%.$(OCAMLEXT)} ; \
	done
	ln -s $(BINDIR)/distcheck $(BINDIR)/debcheck
	ln -s $(BINDIR)/distcheck $(BINDIR)/rpmcheck
	ln -s $(BINDIR)/distcheck $(BINDIR)/eclipsecheck

uninstall: uninstallcudf
	$(OCAMLFIND) remove -destdir $(LIBDIR) $(NAME)

	for f in $$(ls *.$(OCAMLEXT)) ; do \
	  rm -f $(BINDIR)/$${f%.$(OCAMLEXT)} ; \
	done
	rm -f $(BINDIR)/debcheck $(BINDIR)/rpmcheck $(BINDIR)/eclipsecheck

dist: ./$(DIST_TARBALL)
./$(DIST_TARBALL):
	if [ -d ./$(DIST_DIR)/ ] ; then rm -rf ./$(DIST_DIR)/ ; fi
	if [ -d ./$(DIST_TARBALL) ] ; then rm -f ./$(DIST_TARBALL) ; fi
	if [ -d .svn ]; then \
	  svn export . ./$(DIST_DIR) ; \
	else \
	  mkdir ./$(DIST_DIR)/ ; git archive --format=tar HEAD | tar -x -C ./$(DIST_DIR)/ ; \
	fi
	for f in $(DIST_EXCLUDE) ; do rm -rf ./$(DIST_DIR)/$$f; done
	tar cvzf ./$(DIST_TARBALL) ./$(DIST_DIR)
	rm -rf ./$(DIST_DIR)
	@echo "Distribution tarball: ./$(DIST_TARBALL)"

changelog:
	dch -c CHANGES --package $(NAME) -v $(VERSION)

credits:
	@git log --pretty=format:'%aN        %aE' | LC_ALL=C sort -u | awk -F'\t' '{printf("\t%s <%s>\n",$$1,$$2)}';

doc: fast
	$(OCAMLBUILD) $(OBFLAGS) dose3.docdir/index.html dose3.docdir/index.dot
	dot -Grotate=0 -Tsvg -o dose3.docdir/index.svg dose3.docdir/index.dot
	(cd doc && $(MAKE) all)

man:
	cd doc/manpages && $(MAKE)

upload: doc
	(cd doc && $(MAKE) upload)
	rsync -avz -O dose3.docdir/ scm.gforge.inria.fr:/home/groups/dose/htdocs/doc/api/

.PHONY: \
	common algo debian eclipse rpm cws doseparseNoRpm doseparse \
	all fast opt clean top-level headers test tags install uninstall dist doc man

=== doc/Makefile ===
SUBDIRS = manpages debcheck.primer apt-external-solvers.primer
#SHELL=/bin/bash

all:
	@for subdir in $(SUBDIRS); do \
	  (cd $$subdir && $(MAKE)); \
	done

clean:
	@for subdir in $(SUBDIRS); do \
	  (cd $$subdir && $(MAKE) clean); \
	done

webpages:
	cd webpages && $(MAKE) rebuild

upload: webpages
	rsync -avz -O --no-perms manpages/*.html scm.gforge.inria.fr:/home/groups/dose/htdocs/doc/man/
	rsync -avz -O --no-perms debcheck.primer/*.{html,pdf} scm.gforge.inria.fr:/home/groups/dose/htdocs/doc/tools/
	rsync -avz -O --no-perms webpages/public_html/* scm.gforge.inria.fr:/home/groups/dose/htdocs/public_html

=== debian/changelog ===
dose3 (3.3~beta1-3) unstable; urgency=medium

  [ Stefano Zacchiroli ]
  * demote trigger on /usr/share/cudf/solvers from "interest" to
    "interest-noawait": there is no real need to block, and doing so avoid
    trigger cycles. Thanks Guillem Jover for the heads-up.
    (Closes: #772875)

  [ Johannes Schauer ]
  * fix debian/watch (add uversionmangle) 

 -- Stefano Zacchiroli <zack@debian.org>  Fri, 12 Dec 2014 16:39:24 +0100

dose3 (3.3~beta1-1) unstable; urgency=low

  [ Ralf Treinen ]
  * new upstream version:
    - refreshed patches: binaries-prefix-edos, coinstall-binary-name
    - dropped patches that were integrated upstream: buildcheck-manpage,
      buildcheck-manpage-native-arch, multiarch-accept-value-no
  * new patches, cherry-picked from upstream git:
    - doc-target (fix doc target of Makefile)
    - installcudf-target (restore that target which was accidentially dropped)
    - build-cmx (really build cmx)
    - manpages-typos
  * add rudimentary as-installed package tests for dose-debcheck,
    dose-builddebcheck, dose-outdated
  * debian/control: replace Conflicts: by Breaks:
  * debian/copyright: fixed spelling of Alain Frisch
  * debian/copyright: dropped connection-licence which is no longer referred to

  [ Johannes Schauer ]
  * avoid lintian warning binary-control-field-duplicates-source field
    "priority" by removing the Priority field from edos-distcheck in d/control
  * avoid lintian warning vcs-field-not-canonical by modifying the Vcs-Git and
    Vcs-Browser values accordingly
  * the db subdirectory was removed from the upstream source so remove stanza
    from d/copyright
  * bump standards version to 3.9.6
  * avoid lintian warning copyright-refers-to-symlink-license by pointing to
    LGPL-3 license file instead of LGPL
  * d/control: s/debian/Debian/ to avoid capitalization-error-in-description
  * dropped buildcheck-redirect-output because it was integrated upstream

 -- Ralf Treinen <treinen@debian.org>  Tue, 21 Oct 2014 20:28:45 +0200

dose3 (3.2.2-3) unstable; urgency=medium

  * debian/changelog: fix my email address in previous changelog entry.
  * add patch buildcheck-manpage-native-arch: specify in the manpage that
    the --deb-native-arch argument is mandatory to debbuildcheck
    (closes: #757641).
  * add patch multiarch-accept-value-no: when parsing debian metadata,
    accept "no" as alias for "none" as value of Multiarch. Thanks to
    Pietro Abate for the patch (closes: #759372).
  * add patch buildcheck-redirect-output: add option -o to builddebcheck
    which redirects output to a file (closes: #757643).

 -- Ralf Treinen <treinen@debian.org>  Sun, 14 Sep 2014 20:36:02 +0200

=== debian/control ===
Source: dose3
Section: ocaml
Priority: extra
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Stefano Zacchiroli <zack@debian.org>,
 Ralf Treinen <treinen@debian.org>
Build-Depends: debhelper (>= 7.0.50~), dh-ocaml (>= 0.9~),
# use the following line only when autoconf stuff has been patched:
# automake, autoconf,
 ocaml-nox (>= 3.11.1-3~), camlp4,
 libre-ocaml-dev,
 libextlib-ocaml-dev,
 libocamlgraph-ocaml-dev (>= 1.8.5),
 libcudf-ocaml-dev (>= 0.7),
 libzip-ocaml-dev, libbz2-ocaml-dev, librpm-dev (>= 4.8),
 perl, graphviz, hevea, texlive-latex-base, texlive-latex-extra
Standards-Version: 3.9.6
Homepage: http://www.mancoosi.org/software/
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-ocaml-maint/packages/dose3.git
Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/dose3.git
XS-Testsuite: autopkgtest

Package: libdose3-ocaml-dev
Architecture: any
Depends: ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
Provides: ${ocaml:Provides}
Description: OCaml libraries for package dependencies (development files)
 Dose3 is a framework consisting of several OCaml libraries for analysing
 the metadata of software packages (like Packages files of Debian suites).
 .
 Though not tied to any particular distribution, Dose3 constitutes a
 pool of libraries which enable analyzing packages coming from various
 distributions. 
 .
 Besides basic functionalities for querying and setting package
 properties, dose3 also implements algorithms for solving more complex
 problems (monitoring package evolutions, correct and complete
 dependency resolution, repository-wide uninstallability checks).
 .
 This package contains the development stuff you need to use dose3 for
 the development of programs.

Package: libdose3-ocaml
Architecture: any
Depends: ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends} 
Provides: ${ocaml:Provides}
Description: OCaml libraries for package dependencies (runtime files)
 Dose3 is a framework consisting of several OCaml libraries for analysing
 the metadata of software packages (like Packages files of Debian suites).
 .
 Though not tied to any particular distribution, Dose3 constitutes a
 pool of libraries which enable analyzing packages coming from various
 distributions. 
 .
 Besides basic functionalities for querying and setting package
 properties, dose3 also implements algorithms for solving more complex
 problems (monitoring package evolutions, correct and complete
 dependency resolution, repository-wide uninstallability checks).
 .
 This package contains only the shared runtime stub libraries.

Package: dose-distcheck
Section: devel
Architecture: any
Depends: ${ocaml:Depends}, ${misc:Depends}, ${shlibs:Depends}
Breaks: dose3-distcheck (<< 2.9.13)
Replaces: dose3-distcheck (<< 2.9.13)
Description: Checks whether dependencies of packages can be satisfied
 This software checks for every package of a distribution whether it
 is possible to satisfy its dependencies and conflicts within this
 distribution. It comes in several versions:
  - dose-debcheck for Debian packages
  - dose-rpmcheck for rpm packages
  - dose-eclipsecheck for OSGi plugins

Package: dose-builddebcheck
Section: devel
Architecture: any
Depends: ${ocaml:Depends}, ${misc:Depends}, ${shlibs:Depends}
Breaks: dose3-builddebcheck (<< 2.9.13)
Replaces: dose3-builddebcheck (<< 2.9.13)
Description: Checks whether build-dependencies can be satisfied
 This software checks, given a collection of source package stanzas
 and a collection of binary package stanzas of Debian packages, whether
 the build-dependencies of each source package can be satisfied by the
 binary packages.

Package: dose-extra
Section: devel
Architecture: any
Provides: ceve
Breaks: ceve (<< 2.9.10)
Replaces: ceve (<< 2.9.10)
Depends: ${ocaml:Depends}, ${misc:Depends}, ${shlibs:Depends}
Description: Extra QA tools from the Dose3-library
 This package contains extra tools for analyzing meta-data of software 
 packages:
  - ceve, a general metadata parser supporting different input formats
    (Debian, rpm, and others) and different output formats.
  - dose-outdated, a Debian-specific tool for finding packages that are not
    installable with respect to a package repository, and that can only be
    made installable again by fixing the package itself.
  - dose-challenged, a Debian-specific tool for checking which packages
    will certainly become uninstallable when some existing package is upgraded
    to a newer version.
  - dose-coinstall, a Debian-specific tool for checking whether a set of
    packages can be installed all together.
 The tools dose-distcheck and dose-builddebcheck are packaged in their
 own resepective packages.

Package: apt-cudf
Section: admin
Architecture: any
Depends: aspcud | cudf-solver,
 ${ocaml:Depends}, ${perl:Depends}, ${misc:Depends}, ${shlibs:Depends}
Description: CUDF solver integration for APT
 apt-cudf provides integration among the APT package manager and CUDF solvers,
 allowing APT to rely on external (CUDF-based) dependency solvers to plan
 package installation, upgrade, and removal.
 .
 CUDF is a distribution-independent, standard format to describe dependency
 solving scenarios, as faced by package managers in popular package-based
 GNU/Linux distributions. APT is a well-known package manager for Debian-based
 distributions, which is able to delegate dependency solving to external
 solvers, by the means of the External Dependency Solving Protocol (EDSP).
 .
 apt-cudf provides the glue between the EDSP protocol and CUDF solvers,
 enabling any installed CUDF solver to be used as an external solver for APT.
 .
 Several CUDF solvers are available in Debian. They all provide the cudf-solver
 virtual package.

Package: edos-distcheck
Section: oldlibs
Architecture: all
Depends: ${misc:Depends}, dose-distcheck, dose-builddebcheck
Description: Checks dependencies of packages (transitional package)
 This is a transitional package which can be safely removed, its only
 purpose is to ease the transition to the dose3 tools.

## dose3 3.3

=== debian/changelog ===
dose3 (3.3-1) experimental; urgency=medium

  [ Johannes Schauer ]
  * Team upload.
  * new upstream version
    - dropped patches that were integrated upstream: build-cmx, doc-target,
      installcudf-target, manpages-typos, multiarch-accept-value-no
  * fix debian/watch (add uversionmangle) 
  * reorder d/copyright stanzas so that the d/update-cudf-solvers paragraph
    gets used

  [ Ralf Treinen ]
  * install the apt-external-solvers.primer in package apt-cudf:
    - added debian/apt-cudf.docs
    - added debian/apt-cudf.doc-base

 -- Ralf Treinen <treinen@debian.org>  Sat, 22 Nov 2014 14:36:15 +0100

dose3 (3.3~beta1-2) experimental; urgency=low

  * [ Johannes Schauer ]
  * add two patches from upstream to fix botch FTBFS
     - fixMETA fixes the installed META file (closes: #766745)
     - fixDebPrinter restores original printing of Debian packages

 -- Ralf Treinen <treinen@debian.org>  Tue, 11 Nov 2014 17:35:43 +0100

=== debian/rules ===
#!/usr/bin/make -f

RELEASE = $(shell dpkg-parsechangelog | grep ^Version: | cut -f 2 -d' ')
%:
	dh $@ --with ocaml

override_dh_auto_configure:
	rm -f doc/debcheck.primer/version.tex
	# use the following line when autoconf stuff is patched
	# aclocal -I m4 && autoconf
	./configure --with-ocamlgraph --with-zip --with-bz2 --with-rpm4

override_dh_auto_install:
	dh_auto_install
	cd debian/tmp/usr/bin \
		&& mv distcheck dose-distcheck \
		&& mv deb-buildcheck dose-builddebcheck \
		&& mv outdated dose-outdated \
		&& mv challenged dose-challenged \
		&& mv ceve dose-ceve \
		&& mv deb-coinstall dose-deb-coinstall

override_dh_installman:
	dh_installman
	cd debian/dose-distcheck/usr/share/man/man1 \
		&& mv distcheck.1 dose-distcheck.1
	cd debian/dose-extra/usr/share/man/man1 \
		&& mv outdated.1 dose-outdated.1 \
		&& mv challenged.1 dose-challenged.1 \
		&& mv ceve.1 dose-ceve.1 \
		&& mv debcoinstall.1 dose-deb-coinstall.1
	cd debian/dose-builddebcheck/usr/share/man/man1 \
		&& mv buildcheck.1 dose-builddebcheck.1

override_dh_auto_build:
	dh_auto_build
	$(MAKE) doc
	cd doc/debcheck.primer && $(MAKE) 
	pod2man --section 8 -release "apt-cudf $(RELEASE)" \
		debian/update-cudf-solvers > debian/update-cudf-solvers.8

override_dh_auto_clean:
	! [[ -f Makefile.config ]] || make distclean
	rm -f debian/update-cudf-solvers.8
	rm -f _tags

override_dh_auto_test:
	# do nothing

## dose3 4.0.2

=== Makefile ===
#this is a forward reference to the target all below
all: all

#SHELL=/bin/bash
include Makefile.config

DIST_DIR = $(NAME)-$(VERSION)
DIST_TARBALL = $(DIST_DIR).tar.gz

#VERBOSE := -classic-display
OBFLAGS := $(VERBOSE) -j 10 -no-links -cflags -warn-error,FPSXY
APPFLAGS := $(VERBOSE) -j 10
#OBFLAGS := $(OBFLAGS) -tag profile -tag debug
#OBFLAGS := $(OBFLAGS) -classic-display

myocamlbuild.ml: myocamlbuild.ml.pp
	  cppo $(CPPOFLAGS) $< -o $@

all: libs apps man

apps: myocamlbuild.ml itarget $(BYTELIBS) $(OPTLIBS) 
	$(OCAMLBUILD) $(APPFLAGS) applications/apps.otarget

libs: myocamlbuild.ml itarget $(BYTELIBS) $(OPTLIBS) $(CMXSLIBS) $(ALIBS)

cleandoselib:
	rm -Rf $(DOSELIBS)

itarget:
	@rm -f applications/apps.itarget
	@for i in $(TARGETS); do echo $$i >> applications/apps.itarget; done
	@$(shell \
		for lib in $(LIBNAMES); do \
			libname=`basename "$$lib"` ;\
			dirname=`dirname "$$lib"` ;\
			rm -f $$dirname/$$libname.itarget ;\
			for ext in $(SUFFIX); do \
				echo "$$libname.$$ext" >> $$dirname/$$libname.itarget; \
			done;\
		done)

$(DOSELIBS)/cudf.%:
	$(OCAMLBUILD) $(OBFLAGS) cudf/cudf.$*
	@mkdir -p $(DOSELIBS)
	@cp _build/cudf/*.cmi $(DOSELIBS)
	@for i in _build/cudf/cudf.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

$(DOSELIBS)/common.%: common/*.ml
	$(OCAMLBUILD) $(OBFLAGS) common/common.otarget
	@mkdir -p $(DOSELIBS)
	@for i in _build/common/common.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

$(DOSELIBS)/versioning.%: versioning/*.ml
	$(OCAMLBUILD) $(OBFLAGS) versioning/versioning.otarget
	@mkdir -p $(DOSELIBS)
	@for i in _build/versioning/versioning.* _build/versioning/*.cmi; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

$(DOSELIBS)/algo.%: algo/*.ml $(DOSELIBS)/common.%
	$(OCAMLBUILD) $(OBFLAGS) algo/algo.otarget
	@for i in _build/algo/algo.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

$(DOSELIBS)/debian.%: deb/*.ml $(DOSELIBS)/algo.%
	$(OCAMLBUILD) $(OBFLAGS) deb/debian.otarget
	@for i in _build/deb/debian.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

$(DOSELIBS)/rpm.%: rpm/*.ml $(DOSELIBS)/algo.%
	$(OCAMLBUILD) $(OBFLAGS) rpm/rpm.otarget
	@for i in _build/rpm/rpm.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

$(DOSELIBS)/pef.%: pef/*.ml $(DOSELIBS)/debian.%
	$(OCAMLBUILD) $(OBFLAGS) pef/pef.otarget
	@for i in _build/pef/pef.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

$(DOSELIBS)/csw.%: opencsw/*.ml $(DOSELIBS)/debian.%
	$(OCAMLBUILD) $(OBFLAGS) opencsw/csw.otarget
	@for i in _build/opencsw/csw.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

$(DOSELIBS)/doseparse.%: $(DOSELIBS)/debian.% $(DOSELIBS)/pef.%
	$(OCAMLBUILD) $(OBFLAGS) doseparse/doseparse.otarget
	@for i in _build/doseparse/doseparse.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx $(DOSELIBS)/*.ml ; \
	  fi ; \
	done

$(DOSELIBS)/doseparseNoRpm.%: $(DOSELIBS)/debian.% $(DOSELIBS)/pef.%
	$(OCAMLBUILD) $(OBFLAGS) doseparseNoRpm/doseparseNoRpm.otarget
	@for i in _build/doseparseNoRpm/doseparseNoRpm.*; do \
	  if [ -e $$i ]; then \
			cp $$i $(DOSELIBS) ;\
			rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ;\
	  fi ; \
	done

clean:
	$(OCAMLBUILD) -clean
	rm -f myocamlbuild.ml
	rm -f applications/apps.itarget
	cd doc && $(MAKE) clean

distclean: clean
	rm -Rf Makefile.config aclocal.m4 config.log config.status autom4te.cache/
	rm -f algo/algo.mlpack
	rm -f common/versionInfo.ml
	rm -f db/db.mlpack
	rm -f _tags META

test: apps
ifeq (libs,$(word 2,$(MAKECMDGOALS)))
	$(MAKE) testlib
else
ifdef group
	applications/dose-tests.py --rungroup $(group) applications/dose-tests.list
else 
ifdef unit
	applications/dose-tests.py --runtest $(unit) applications/dose-tests.list
else
	$(MAKE) testlib
	applications/dose-tests.py applications/dose-tests.list
endif
endif
endif

testlib: 
	@for i in $(TESTS); do\
		echo "#######START TESTING $$i" ;\
		$(OCAMLBUILD) $(APPFLAGS) $$i/tests.$(OCAMLEXT) || exit 1;\
		./tests.$(OCAMLEXT) || exit 1;\
	done

# stuff not not put in a distribution tarball
DIST_EXCLUDE = cudf tests $(wildcard */tests) experimental doc/webpages

INSTALL_STUFF_ = META
INSTALL_STUFF_ += $(wildcard _build/doselibs/*.cma _build/doselibs/*.cmi)
INSTALL_STUFF_ += $(wildcard _build/doselibs/*.cmxa _build/doselibs/*.cmxs)
INSTALL_STUFF_ += $(wildcard _build/doselibs/*.a)
INSTALL_STUFF_ += $(wildcard _build/*/*.mli)
INSTALL_STUFF_ += $(wildcard _build/rpm/*.so)

exclude_cudf = $(wildcard _build/doselibs/*cudf* _build/cudf/*)
INSTALL_STUFF = $(filter-out $(exclude_cudf), $(INSTALL_STUFF_))

installlib: META installcudf
	@test -d $(LIBDIR) || mkdir -p $(LIBDIR)
	@test -d $(LIBDIR)/stublibs || mkdir -p $(LIBDIR)/stublibs
	@$(INSTALL) -patch-version $(VERSION) $(NAME) $(INSTALL_STUFF)
	@echo "Install dose librairies to $(LIBDIR)"

install: installlib
	@cd _build/applications ; \
	install -d $(BINDIR) ; \
	for f in $$(ls *.$(OCAMLEXT)) ; do \
	  install $(INSTALLOPTS) $$f $(BINDIR)/$${f%.$(OCAMLEXT)} ; \
	done
	@ln -s $(BINDIR)/distcheck $(BINDIR)/debcheck
	@ln -s $(BINDIR)/distcheck $(BINDIR)/rpmcheck
	@ln -s $(BINDIR)/distcheck $(BINDIR)/eclipsecheck
	@echo "Install dose binaries to $(BINDIR)"

uninstalllib:
	@$(OCAMLFIND) remove -destdir $(LIBDIR) $(NAME)
	@echo "Uninstall dose librairies from $(LIBDIR)"

uninstall: uninstalllib uninstallcudf
	@for f in $$(ls *.$(OCAMLEXT)) ; do \
	  rm -f $(BINDIR)/$${f%.$(OCAMLEXT)} ; \
	done
	@rm -f $(BINDIR)/debcheck $(BINDIR)/rpmcheck $(BINDIR)/eclipsecheck
	@echo "Uninstall dose binaries from $(BINDIR)"

dist: ./$(DIST_TARBALL)
./$(DIST_TARBALL):
	@if [ -d ./$(DIST_DIR)/ ] ; then rm -rf ./$(DIST_DIR)/ ; fi
	@if [ -d ./$(DIST_TARBALL) ] ; then rm -f ./$(DIST_TARBALL) ; fi
	@mkdir ./$(DIST_DIR)/ ; git archive --format=tar HEAD | tar -x -C ./$(DIST_DIR)/
	@for f in $(DIST_EXCLUDE) ; do rm -rf ./$(DIST_DIR)/$$f; done
	@tar czf ./$(DIST_TARBALL) ./$(DIST_DIR)
	@rm -rf ./$(DIST_DIR)
	@echo "Distribution tarball: ./$(DIST_TARBALL)"

changelog:
	dch -c CHANGES --package $(NAME) -v $(VERSION)

credits:
	@git log --pretty=format:'%aN        %aE' | LC_ALL=C sort -u | awk -F'\t' '{printf("\t%s <%s>\n",$$1,$$2)}';

doc: all
	$(OCAMLBUILD) dose3.docdir/index.html dose3.docdir/index.dot
	dot -Grotate=0 -Tsvg -o dose3.docdir/index.svg dose3.docdir/index.dot
	(cd doc && $(MAKE) all)

man:
	cd doc/manpages && $(MAKE)

upload: doc
	(cd doc && $(MAKE) upload)
	rsync -avz -O dose3.docdir/ scm.gforge.inria.fr:/home/groups/dose/htdocs/doc/api/

.PHONY: \
	common algo debian pef rpm cws doseparseNoRpm doseparse \
	all clean top-level headers test tags install uninstall dist doc man

=== debian/changelog ===
dose3 (4.0.2-4) unstable; urgency=medium

  * Team upload.
  * Disable call to dot during build to avoid FTBFS on some architectures
    (Closes: #809049).

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 03 Jan 2016 11:17:07 +0100

dose3 (4.0.2-3) unstable; urgency=medium

  * revert modifications done for 4.0.2-2 and restore generation of ocamldoc
    documentation since this is fixed now in ocaml.

 -- Ralf Treinen <treinen@debian.org>  Thu, 24 Dec 2015 12:12:42 +0100

dose3 (4.0.2-2) unstable; urgency=medium

  * skip generation of ocamldoc documentation  since it fails with ocaml 4.02
    (closes: #801773):
    - patch skip-ocamldoc
    - debian/libdose3-ocaml-dev.docs
    - drop debian/libdose3-ocaml-dev.doc-base

 -- Ralf Treinen <treinen@debian.org>  Fri, 16 Oct 2015 19:12:52 +0200

dose3 (4.0.2-1) unstable; urgency=medium

  * New upstream release
  * remove patch fix_META (was included upstream)

 -- Johannes Schauer <josch@debian.org>  Sun, 27 Sep 2015 11:14:42 +0200

dose3 (4.0.1-2) unstable; urgency=medium

  * add patch fix_META (Closes: #797448)

 -- Johannes Schauer <josch@debian.org>  Mon, 14 Sep 2015 19:18:38 +0200

dose3 (4.0.1-1) unstable; urgency=medium

  [ Johannes Schauer ]
  * New upstream release (Closes: #797448):
    - upstream dropped doc/webpages directory so remove debian/missing-sources
      and the corresponding sections from debian/copyright
    - remove patch make-doc-target-work as upstream fixed this
    - bump version requirement for libextlib-ocaml-dev to 1.7.0 because
      upstream requires implementation for custom exit values if wrong command
      line options are passed

  [ Ralf Treinen ]
  * d/dose-distcheck.NEWS: inform about changes in output format and command
    line options

 -- Johannes Schauer <josch@debian.org>  Tue, 01 Sep 2015 11:02:51 +0200

dose3 (4.0-1) unstable; urgency=medium

  [ Ralf Treinen ]
  * New upstream release:
    - refresh patches: binaries-prefix-edos, coinstall-binary-name
    - deactivate patches: librpm-4.12
  * drop the edos-distcheck transitional package.
  * Replaced build-dependency camlp4 by cppo, following upstream
  * debian/rules: simplify override_dh_auto_build (primers are now built by
    upstream's make doc)

  [ Johannes Schauer ]
  * remove patches cudfSolver-fix-leaking-fds and
    encode-package-name-in-cudf_extras which have been integrated upstream
  * upstream moved ./deb/format822.ml to ./common. Adjusting d/copyright
    accordingly
  * upstream moved ./deb/version.ml to ./versioning/debian_version.ml.
    Adjusting d/copyright accordingly.
  * add d/copyright paragraph for common/shell_lexer.mll
  * add patch make-doc-target-work to make `make doc` work again
  * bump d/compat to 9. It has been in stable since wheezy and even
    old-old-stable has debhelper (>= 9) in backports.
  * simplify override_dh_auto_configure target
  * run dh-autoreconf to make sure that everything can truly be built from
    source
  * add debian/missing-sources for bootstrap.min.js and jquery-2.1.3.min.js
    and add debian/README.source to explain the situation
  * add d/copyright paragraphs for bootstrap.min.js, jquery-2.1.3.min.js and
    their unminified versions in debian/missing-sources
  * add doc/webpages to Files-Excluded in d/copyright

 -- Johannes Schauer <josch@debian.org>  Thu, 27 Aug 2015 12:00:35 +0200

dose3 (3.3-4) unstable; urgency=low

  * update patch binaries-prefix-edos: fix name of dose-deb-coinstall
    (closes: #789331).
  * patch librpm-4.12: Fix FTBFS with librpm-dev 4.12. Patch extracted
    from upstream git, commit 1d0ed0a. Bump build-dependency on librpm-dev
    to >= 4.12 (closes: #789354).
  * d/control: XS-Testsuite => Testsuite

 -- Ralf Treinen <treinen@debian.org>  Tue, 23 Jun 2015 20:48:33 +0200

dose3 (3.3-3) unstable; urgency=medium

  * upload to unstable

 -- Johannes Schauer <josch@debian.org>  Tue, 05 May 2015 21:35:59 +0200

dose3 (3.3-2) experimental; urgency=medium

  * backport patch cudfSolver-fix-leaking-fds to work around libcudf bug
    https://gforge.inria.fr/tracker/index.php?func=detail&aid=18789&group_id=4385&atid=13811
  * added myself to the Uploaders field
  * remove fixDebPrinter and fixMETA from debian/patches as they were
    unused
  * backport patch encode-package-name-in-cudf_extras to prepare for switch
    of cudf encoding of Debian package names in next dose3 release
  * backport patch remove_src_prefix_from_name

 -- Johannes Schauer <josch@debian.org>  Fri, 27 Mar 2015 08:48:14 +0100

=== debian/control ===
--- 
+++ 
@@ -3,22 +3,23 @@
 Priority: extra
 Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Stefano Zacchiroli <zack@debian.org>,
- Ralf Treinen <treinen@debian.org>
-Build-Depends: debhelper (>= 7.0.50~), dh-ocaml (>= 0.9~),
+ Ralf Treinen <treinen@debian.org>,
+ Johannes Schauer <josch@debian.org>
+Build-Depends: debhelper (>= 9), dh-ocaml (>= 0.9~), dh-autoreconf,
 # use the following line only when autoconf stuff has been patched:
 # automake, autoconf,
- ocaml-nox (>= 3.11.1-3~), camlp4,
+ ocaml-nox (>= 3.11.1-3~), cppo,
  libre-ocaml-dev,
- libextlib-ocaml-dev,
+ libextlib-ocaml-dev (>= 1.7.0),
  libocamlgraph-ocaml-dev (>= 1.8.5),
  libcudf-ocaml-dev (>= 0.7),
- libzip-ocaml-dev, libbz2-ocaml-dev, librpm-dev (>= 4.8),
+ libzip-ocaml-dev, libbz2-ocaml-dev, librpm-dev (>= 4.12),
  perl, graphviz, hevea, texlive-latex-base, texlive-latex-extra
 Standards-Version: 3.9.6
 Homepage: http://www.mancoosi.org/software/
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-ocaml-maint/packages/dose3.git
 Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/dose3.git
-XS-Testsuite: autopkgtest
+Testsuite: autopkgtest
 
 Package: libdose3-ocaml-dev
 Architecture: any
@@ -129,11 +130,3 @@
  .
  Several CUDF solvers are available in Debian. They all provide the cudf-solver
  virtual package.
-
-Package: edos-distcheck
-Section: oldlibs
-Architecture: all
-Depends: ${misc:Depends}, dose-distcheck, dose-builddebcheck
-Description: Checks dependencies of packages (transitional package)
- This is a transitional package which can be safely removed, its only
- purpose is to ease the transition to the dose3 tools.

=== debian/rules ===
--- 
+++ 
@@ -2,13 +2,10 @@
 
 RELEASE = $(shell dpkg-parsechangelog | grep ^Version: | cut -f 2 -d' ')
 %:
-	dh $@ --with ocaml
+	dh $@ --with ocaml --with autoreconf
 
 override_dh_auto_configure:
-	rm -f doc/debcheck.primer/version.tex
-	# use the following line when autoconf stuff is patched
-	# aclocal -I m4 && autoconf
-	./configure --with-ocamlgraph --with-zip --with-bz2 --with-rpm4
+	dh_auto_configure -- --with-ocamlgraph --with-zip --with-bz2 --with-rpm4
 
 override_dh_auto_install:
 	dh_auto_install
@@ -35,7 +32,6 @@
 override_dh_auto_build:
 	dh_auto_build
 	$(MAKE) doc
-	cd doc/debcheck.primer && $(MAKE) 
 	pod2man --section 8 -release "apt-cudf $(RELEASE)" \
 		debian/update-cudf-solvers > debian/update-cudf-solvers.8

=== debian/tests/control ===
Tests: dose-debcheck
Depends: dose-distcheck

Tests: dose-builddebcheck
Depends: dose-builddebcheck

Tests: dose-outdated
Depends: dose-extra

## dose3 4.1

=== Makefile ===
--- 
+++ 
@@ -13,15 +13,23 @@
 #OBFLAGS := $(OBFLAGS) -tag profile -tag debug
 #OBFLAGS := $(OBFLAGS) -classic-display
 
+addnotrpm:
+	@if [ ! -s doseparseNoRpm ]; then $(LN) doseparse doseparseNoRpm ; fi
+	@cd doseparse ; \
+		if [ ! -s doseparseNoRpm.mlpack ]; then \
+			$(LN) doseparse.mlpack doseparseNoRpm.mlpack ; \
+		fi ; \
+	cd -
+
 myocamlbuild.ml: myocamlbuild.ml.pp
-	  cppo $(CPPOFLAGS) $< -o $@
+	cppo $(CPPOFLAGS) $< -o $@
 
 all: libs apps man
 
-apps: myocamlbuild.ml itarget $(BYTELIBS) $(OPTLIBS) 
+apps: addnotrpm myocamlbuild.ml itarget $(BYTELIBS) $(OPTLIBS) 
 	$(OCAMLBUILD) $(APPFLAGS) applications/apps.otarget
 
-libs: myocamlbuild.ml itarget $(BYTELIBS) $(OPTLIBS) $(CMXSLIBS) $(ALIBS)
+libs: addnotrpm myocamlbuild.ml itarget $(BYTELIBS) $(OPTLIBS) $(CMXSLIBS) $(ALIBS)
 
 cleandoselib:
 	rm -Rf $(DOSELIBS)
@@ -50,7 +58,7 @@
 	  fi ; \
 	done
 
-$(DOSELIBS)/common.%: common/*.ml
+$(DOSELIBS)/common.%: common/*.ml common/*.mli
 	$(OCAMLBUILD) $(OBFLAGS) common/common.otarget
 	@mkdir -p $(DOSELIBS)
 	@for i in _build/common/common.*; do \
@@ -60,17 +68,17 @@
 	  fi ; \
 	done
 
-$(DOSELIBS)/versioning.%: versioning/*.ml
+$(DOSELIBS)/versioning.%: versioning/*.ml versioning/*.mli
 	$(OCAMLBUILD) $(OBFLAGS) versioning/versioning.otarget
 	@mkdir -p $(DOSELIBS)
-	@for i in _build/versioning/versioning.* _build/versioning/*.cmi; do \
-	  if [ -e $$i ]; then \
-	  cp $$i $(DOSELIBS) ; \
-	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
-	  fi ; \
-	done
-
-$(DOSELIBS)/algo.%: algo/*.ml $(DOSELIBS)/common.%
+	@for i in _build/versioning/versioning.*; do \
+	  if [ -e $$i ]; then \
+	  cp $$i $(DOSELIBS) ; \
+	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
+	  fi ; \
+	done
+
+$(DOSELIBS)/algo.%: algo/*.ml algo/*.mli $(DOSELIBS)/common.%
 	$(OCAMLBUILD) $(OBFLAGS) algo/algo.otarget
 	@for i in _build/algo/algo.*; do \
 	  if [ -e $$i ]; then \
@@ -79,9 +87,18 @@
 	  fi ; \
 	done
 
-$(DOSELIBS)/debian.%: deb/*.ml $(DOSELIBS)/algo.%
+$(DOSELIBS)/debian.%: deb/*.ml deb/*.mli $(DOSELIBS)/pef.%
 	$(OCAMLBUILD) $(OBFLAGS) deb/debian.otarget
 	@for i in _build/deb/debian.*; do \
+	  if [ -e $$i ]; then \
+	  cp $$i $(DOSELIBS) ; \
+	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
+	  fi ; \
+	done
+
+$(DOSELIBS)/opam.%: opam/*.ml opam/*.mli $(DOSELIBS)/pef.%
+	$(OCAMLBUILD) $(OBFLAGS) opam/opam.otarget
+	@for i in _build/opam/opam.*; do \
 	  if [ -e $$i ]; then \
 	  cp $$i $(DOSELIBS) ; \
 	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
@@ -97,7 +114,7 @@
 	  fi ; \
 	done
 
-$(DOSELIBS)/pef.%: pef/*.ml $(DOSELIBS)/debian.%
+$(DOSELIBS)/pef.%: pef/*.ml pef/*.mli
 	$(OCAMLBUILD) $(OBFLAGS) pef/pef.otarget
 	@for i in _build/pef/pef.*; do \
 	  if [ -e $$i ]; then \
@@ -106,7 +123,7 @@
 	  fi ; \
 	done
 
-$(DOSELIBS)/csw.%: opencsw/*.ml $(DOSELIBS)/debian.%
+$(DOSELIBS)/csw.%: opencsw/*.ml $(DOSELIBS)/versioning.%
 	$(OCAMLBUILD) $(OBFLAGS) opencsw/csw.otarget
 	@for i in _build/opencsw/csw.*; do \
 	  if [ -e $$i ]; then \
@@ -115,7 +132,7 @@
 	  fi ; \
 	done
 
-$(DOSELIBS)/doseparse.%: $(DOSELIBS)/debian.% $(DOSELIBS)/pef.%
+$(DOSELIBS)/doseparse.%: $(DOSELIBS)/pef.% $(DOSELIBS)/debian.%
 	$(OCAMLBUILD) $(OBFLAGS) doseparse/doseparse.otarget
 	@for i in _build/doseparse/doseparse.*; do \
 	  if [ -e $$i ]; then \
@@ -124,7 +141,7 @@
 	  fi ; \
 	done
 
-$(DOSELIBS)/doseparseNoRpm.%: $(DOSELIBS)/debian.% $(DOSELIBS)/pef.%
+$(DOSELIBS)/doseparseNoRpm.%: $(DOSELIBS)/pef.% $(DOSELIBS)/debian.%
 	$(OCAMLBUILD) $(OBFLAGS) doseparseNoRpm/doseparseNoRpm.otarget
 	@for i in _build/doseparseNoRpm/doseparseNoRpm.*; do \
 	  if [ -e $$i ]; then \
@@ -135,8 +152,15 @@
 
 clean:
 	$(OCAMLBUILD) -clean
+	@$(shell \
+		for lib in $(LIBNAMES); do \
+			libname=`basename "$$lib"` ;\
+			dirname=`dirname "$$lib"` ;\
+			rm -f $$dirname/$$libname.itarget ;\
+		done)
 	rm -f myocamlbuild.ml
 	rm -f applications/apps.itarget
+	rm -f doseparseNoRpm doseparse/doseparseNoRpm.mlpack
 	cd doc && $(MAKE) clean
 
 distclean: clean
@@ -144,7 +168,7 @@
 	rm -f algo/algo.mlpack
 	rm -f common/versionInfo.ml
 	rm -f db/db.mlpack
-	rm -f _tags META
+	rm -f _tags META applications/dose-tests.list dose3.odocl
 
 test: apps
 ifeq (libs,$(word 2,$(MAKECMDGOALS)))
@@ -176,7 +200,7 @@
 INSTALL_STUFF_ += $(wildcard _build/doselibs/*.cma _build/doselibs/*.cmi)
 INSTALL_STUFF_ += $(wildcard _build/doselibs/*.cmxa _build/doselibs/*.cmxs)
 INSTALL_STUFF_ += $(wildcard _build/doselibs/*.a)
-INSTALL_STUFF_ += $(wildcard _build/*/*.mli)
+#INSTALL_STUFF_ += $(wildcard _build/*/*.mli)
 INSTALL_STUFF_ += $(wildcard _build/rpm/*.so)
 
 exclude_cudf = $(wildcard _build/doselibs/*cudf* _build/cudf/*)
@@ -192,11 +216,11 @@
 	@cd _build/applications ; \
 	install -d $(BINDIR) ; \
 	for f in $$(ls *.$(OCAMLEXT)) ; do \
-	  install $(INSTALLOPTS) $$f $(BINDIR)/$${f%.$(OCAMLEXT)} ; \
-	done
-	@ln -s $(BINDIR)/distcheck $(BINDIR)/debcheck
-	@ln -s $(BINDIR)/distcheck $(BINDIR)/rpmcheck
-	@ln -s $(BINDIR)/distcheck $(BINDIR)/eclipsecheck
+		install $(INSTALLOPTS) $$f $(BINDIR)/$${f%.$(OCAMLEXT)}$(EXE) ; \
+	done
+	@$(LN) $(BINDIR)/distcheck $(BINDIR)/debcheck$(EXE)
+	@$(LN) $(BINDIR)/distcheck $(BINDIR)/rpmcheck$(EXE)
+	@$(LN) $(BINDIR)/distcheck $(BINDIR)/eclipsecheck$(EXE)
 	@echo "Install dose binaries to $(BINDIR)"
 
 uninstalllib:
@@ -205,9 +229,9 @@
 
 uninstall: uninstalllib uninstallcudf
 	@for f in $$(ls *.$(OCAMLEXT)) ; do \
-	  rm -f $(BINDIR)/$${f%.$(OCAMLEXT)} ; \
-	done
-	@rm -f $(BINDIR)/debcheck $(BINDIR)/rpmcheck $(BINDIR)/eclipsecheck
+	  rm -f $(BINDIR)/$${f%.$(OCAMLEXT)}$(EXE) ; \
+	done
+	@rm -f $(BINDIR)/debcheck$(EXE) $(BINDIR)/rpmcheck$(EXE) $(BINDIR)/eclipsecheck$(EXE)
 	@echo "Uninstall dose binaries from $(BINDIR)"
 
 dist: ./$(DIST_TARBALL)
@@ -227,7 +251,8 @@
 	@git log --pretty=format:'%aN        %aE' | LC_ALL=C sort -u | awk -F'\t' '{printf("\t%s <%s>\n",$$1,$$2)}';
 
 doc: all
-	$(OCAMLBUILD) dose3.docdir/index.html dose3.docdir/index.dot
+	$(OCAMLBUILD) -package unix scripts/pack.native
+	scripts/doc.sh $(OCAMLEXT)
 	dot -Grotate=0 -Tsvg -o dose3.docdir/index.svg dose3.docdir/index.dot
 	(cd doc && $(MAKE) all)
 
@@ -239,5 +264,5 @@
 	rsync -avz -O dose3.docdir/ scm.gforge.inria.fr:/home/groups/dose/htdocs/doc/api/
 
 .PHONY: \
-	common algo debian pef rpm cws doseparseNoRpm doseparse \
+	common algo pef versioning debian rpm csw doseparseNoRpm doseparse \
 	all clean top-level headers test tags install uninstall dist doc man

=== debian/changelog ===
dose3 (4.1-4) unstable; urgency=medium

  * patch lexing-debian-fields: syntax of debian fields according to
    debian policy. Patch taken from upstream. (closes: #811569)
  * patch add-gnuhardened1-linux: compile on hardenend1-linux-amd64. Thanks
    to Balint Reczey for the patch! (closes: #812786)
  * fix name of dose-deb-coinstall in package description of dose-extra
    (closes: #812203)
  * dose-{distcheck,builddebcheck}.NEWS: announce changes in printing of
    package names (closes: #810303)
  * add test cases for bug#811569 and bug#790422.

 -- Ralf Treinen <treinen@debian.org>  Sun, 07 Feb 2016 18:36:16 +0100

dose3 (4.1-3) unstable; urgency=medium

  * Fix META file: debian.cm{,x}a needs pef.cm{,x}a. The latter must
    appear first in the META file.
  * Add patch to correclty compute max_int on 32bits architectures
    (Closes: #810513). Thanks to Julian Andres Klode for the patch.

 -- Mehdi Dogguy <mehdi@debian.org>  Sat, 09 Jan 2016 20:01:04 +0100

dose3 (4.1-2) unstable; urgency=medium

  * Team upload.
  * Fix FTBFS on bytecode architectures.
    - add patch fix_ftbfs_on_bytecode_arch

 -- Mehdi Dogguy <mehdi@debian.org>  Thu, 07 Jan 2016 22:07:30 +0100

dose3 (4.1-1) unstable; urgency=medium

  * new upstream version. This release implements versioned provides
    (Closes: #786671).
    - refreshed patch disable-dot.
  * configure: explicit --bindir and --libdir

 -- Ralf Treinen <treinen@debian.org>  Thu, 07 Jan 2016 18:49:53 +0100

dose3 (4.1~beta1-1) experimental; urgency=medium

  * new upstream version
    - refreshed patch coinstall-binary-name
    - dropped patch coinstall-binary-name, fixed upstream
  * bump version of build-dependency ocamlgraph and ocaml-nox

 -- Ralf Treinen <treinen@debian.org>  Thu, 24 Dec 2015 14:52:09 +0100

=== debian/control ===
--- 
+++ 
@@ -8,10 +8,10 @@
 Build-Depends: debhelper (>= 9), dh-ocaml (>= 0.9~), dh-autoreconf,
 # use the following line only when autoconf stuff has been patched:
 # automake, autoconf,
- ocaml-nox (>= 3.11.1-3~), cppo,
+ ocaml-nox (>= 3.11.2), cppo,
  libre-ocaml-dev,
  libextlib-ocaml-dev (>= 1.7.0),
- libocamlgraph-ocaml-dev (>= 1.8.5),
+ libocamlgraph-ocaml-dev (>= 1.8.6),
  libcudf-ocaml-dev (>= 0.7),
  libzip-ocaml-dev, libbz2-ocaml-dev, librpm-dev (>= 4.12),
  perl, graphviz, hevea, texlive-latex-base, texlive-latex-extra
@@ -104,7 +104,7 @@
   - dose-challenged, a Debian-specific tool for checking which packages
     will certainly become uninstallable when some existing package is upgraded
     to a newer version.
-  - dose-coinstall, a Debian-specific tool for checking whether a set of
+  - dose-deb-coinstall, a Debian-specific tool for checking whether a set of
     packages can be installed all together.
  The tools dose-distcheck and dose-builddebcheck are packaged in their
  own resepective packages.

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,9 @@
 	dh $@ --with ocaml --with autoreconf
 
 override_dh_auto_configure:
-	dh_auto_configure -- --with-ocamlgraph --with-zip --with-bz2 --with-rpm4
+	dh_auto_configure -- --with-ocamlgraph --with-zip \
+			--with-bz2 --with-rpm4 \
+			--bindir=/usr/bin --libdir=/usr/lib
 
 override_dh_auto_install:
 	dh_auto_install
